> For the complete documentation index, see [llms.txt](https://docs.fulfillmenttools.com/documentation/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.fulfillmenttools.com/documentation/apis/customer-defined-ids-in-requests.md).

# Customer-defined IDs in requests

fulfillmenttools lets you specify a user-defined ID for certain entities. The ID format follows the pattern `tenant{ENTITY}Id`, for example, `tenantArticleId` or `tenantStockId`. This field allows you to transfer IDs from external systems to fulfillmenttools. If this ID is unambiguous, you can read and write the entity using HTTP.

Currently, this functionality applies only to stock entities.

{% hint style="info" %}
For information on retrieving entities by their `tenant{ENTITY}Id` using a path parameter, refer to the [Uniform Resource Name (URN) pattern in path parameters](https://docs.fulfillmenttools.com/documentation/apis/api-reference.md#uniform-resource-name-pattern-urn-in-path-parameters) documentation.
{% endhint %}

## Examples for stock

Let's say we have our facility with a `tenantFacilityId` of `CGN-01`, a `tenantArticleId` of `Art-42`, and a `tenantStockId` of `Stock-01`.

### Get stock with a user-defined ID

We can get all the stock for our facility using the `tenantFacilityId` query parameter:

```http
GET https://ocff-{projectId}.api.fulfillmenttools.com/api/stocks?tenantFacilityId=CGN-01
```

### Search for stock with a user-defined ID

We can get our particular stock using the `tenantStockId` query in the stock search `POST`:

{% tabs %}
{% tab title="Endpoint" %}

```http
POST https://ocff-{projectId}.api.fulfillmenttools.com/api/stocks/search
```

{% endtab %}

{% tab title="Request" %}

```json
{
    "query": {
        "tenantStockId": {
            "eq": "Stock-01"
        }
    }
}
```

{% endtab %}
{% endtabs %}

### Create stock with a user-defined ID via PUT

We can add stock to an item in a facility using the `tenantFacilityId` and `tenantArticleId` in the stock `PUT`:

{% tabs %}
{% tab title="Endpoint" %}

```http
PUT https://ocff-{projectId}.api.fulfillmenttools.com/api/stocks
```

{% endtab %}

{% tab title="Request" %}

```json
{
    "stocks": [
        {
            "facility": {
                "tenantFacilityId": "CGN-01"
            },
            "tenantArticleId": "Art-42",
            "value": 100
        }
    ]
}
```

{% endtab %}
{% endtabs %}

### Create a stock with a user-defined ID via POST

We can add stock to an item in a facility using the `tenantFacilityId` and `tenantArticleId` in the stock `POST`:

{% tabs %}
{% tab title="Endpoint" %}

```http
POST https://ocff-{projectId}.api.fulfillmenttools.com/api/stocks
```

{% endtab %}

{% tab title="Request" %}

```json
{
    "facility": {
        "tenantFacilityId": "CGN-01"
    },
    "tenantArticleId": "Art-42",
    "value": 101
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.fulfillmenttools.com/documentation/apis/customer-defined-ids-in-requests.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
